diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/sysendian.h tarsnap-autoconf-1.0.34/libcperciva/util/sysendian.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/sysendian.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/sysendian.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,146 @@
+#ifndef _SYSENDIAN_H_
+#define _SYSENDIAN_H_
+
+#include <stdint.h>
+
+/* Avoid namespace collisions with BSD <sys/endian.h>. */
+#define be16dec libcperciva_be16dec
+#define be16enc libcperciva_be16enc
+#define be32dec libcperciva_be32dec
+#define be32enc libcperciva_be32enc
+#define be64dec libcperciva_be64dec
+#define be64enc libcperciva_be64enc
+#define le16dec libcperciva_le16dec
+#define le16enc libcperciva_le16enc
+#define le32dec libcperciva_le32dec
+#define le32enc libcperciva_le32enc
+#define le64dec libcperciva_le64dec
+#define le64enc libcperciva_le64enc
+
+static inline uint16_t
+be16dec(const void *pp)
+{
+	const uint8_t *p = (uint8_t const *)pp;
+
+	return ((uint16_t)(p[1]) + ((uint16_t)(p[0]) << 8));
+}
+
+static inline void
+be16enc(void *pp, uint16_t x)
+{
+	uint8_t * p = (uint8_t *)pp;
+
+	p[1] = x & 0xff;
+	p[0] = (x >> 8) & 0xff;
+}
+
+static inline uint32_t
+be32dec(const void *pp)
+{
+	const uint8_t *p = (uint8_t const *)pp;
+
+	return ((uint32_t)(p[3]) + ((uint32_t)(p[2]) << 8) +
+	    ((uint32_t)(p[1]) << 16) + ((uint32_t)(p[0]) << 24));
+}
+
+static inline void
+be32enc(void *pp, uint32_t x)
+{
+	uint8_t * p = (uint8_t *)pp;
+
+	p[3] = x & 0xff;
+	p[2] = (x >> 8) & 0xff;
+	p[1] = (x >> 16) & 0xff;
+	p[0] = (x >> 24) & 0xff;
+}
+
+static inline uint64_t
+be64dec(const void *pp)
+{
+	const uint8_t *p = (uint8_t const *)pp;
+
+	return ((uint64_t)(p[7]) + ((uint64_t)(p[6]) << 8) +
+	    ((uint64_t)(p[5]) << 16) + ((uint64_t)(p[4]) << 24) +
+	    ((uint64_t)(p[3]) << 32) + ((uint64_t)(p[2]) << 40) +
+	    ((uint64_t)(p[1]) << 48) + ((uint64_t)(p[0]) << 56));
+}
+
+static inline void
+be64enc(void *pp, uint64_t x)
+{
+	uint8_t * p = (uint8_t *)pp;
+
+	p[7] = x & 0xff;
+	p[6] = (x >> 8) & 0xff;
+	p[5] = (x >> 16) & 0xff;
+	p[4] = (x >> 24) & 0xff;
+	p[3] = (x >> 32) & 0xff;
+	p[2] = (x >> 40) & 0xff;
+	p[1] = (x >> 48) & 0xff;
+	p[0] = (x >> 56) & 0xff;
+}
+
+static inline uint16_t
+le16dec(const void *pp)
+{
+	const uint8_t *p = (uint8_t const *)pp;
+
+	return ((uint16_t)(p[0]) + ((uint16_t)(p[1]) << 8));
+}
+
+static inline void
+le16enc(void *pp, uint16_t x)
+{
+	uint8_t * p = (uint8_t *)pp;
+
+	p[0] = x & 0xff;
+	p[1] = (x >> 8) & 0xff;
+}
+
+static inline uint32_t
+le32dec(const void *pp)
+{
+	const uint8_t *p = (uint8_t const *)pp;
+
+	return ((uint32_t)(p[0]) + ((uint32_t)(p[1]) << 8) +
+	    ((uint32_t)(p[2]) << 16) + ((uint32_t)(p[3]) << 24));
+}
+
+static inline void
+le32enc(void *pp, uint32_t x)
+{
+	uint8_t * p = (uint8_t *)pp;
+
+	p[0] = x & 0xff;
+	p[1] = (x >> 8) & 0xff;
+	p[2] = (x >> 16) & 0xff;
+	p[3] = (x >> 24) & 0xff;
+}
+
+static inline uint64_t
+le64dec(const void *pp)
+{
+	const uint8_t *p = (uint8_t const *)pp;
+
+	return ((uint64_t)(p[0]) + ((uint64_t)(p[1]) << 8) +
+	    ((uint64_t)(p[2]) << 16) + ((uint64_t)(p[3]) << 24) +
+	    ((uint64_t)(p[4]) << 32) + ((uint64_t)(p[5]) << 40) +
+	    ((uint64_t)(p[6]) << 48) + ((uint64_t)(p[7]) << 56));
+}
+
+static inline void
+le64enc(void *pp, uint64_t x)
+{
+	uint8_t * p = (uint8_t *)pp;
+
+	p[0] = x & 0xff;
+	p[1] = (x >> 8) & 0xff;
+	p[2] = (x >> 16) & 0xff;
+	p[3] = (x >> 24) & 0xff;
+	p[4] = (x >> 32) & 0xff;
+	p[5] = (x >> 40) & 0xff;
+	p[6] = (x >> 48) & 0xff;
+	p[7] = (x >> 56) & 0xff;
+}
+
+#endif /* !_SYSENDIAN_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/warnp.c tarsnap-autoconf-1.0.34/libcperciva/util/warnp.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/warnp.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/warnp.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,76 @@
+#include <errno.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "warnp.h"
+
+static int initialized = 0;
+static char * name = NULL;
+
+/* Free the name string. */
+static void
+done(void)
+{
+
+	free(name);
+	name = NULL;
+}
+
+/**
+ * warnp_setprogname(progname):
+ * Set the program name to be used by warn() and warnx() to ${progname}.
+ */
+void
+warnp_setprogname(const char * progname)
+{
+	const char * p;
+
+	/* Free the name if we already have one. */
+	free(name);
+
+	/* Find the last segment of the program name. */
+	for (p = progname; progname[0] != '\0'; progname++)
+		if (progname[0] == '/')
+			p = progname + 1;
+
+	/* Copy the name string. */
+	name = strdup(p);
+
+	/* If we haven't already done so, register our exit handler. */
+	if (initialized == 0) {
+		atexit(done);
+		initialized = 1;
+	}
+}
+
+void
+warn(const char * fmt, ...)
+{
+	va_list ap;
+
+	va_start(ap, fmt);
+	fprintf(stderr, "%s", (name != NULL) ? name : "(unknown)");
+	if (fmt != NULL) {
+		fprintf(stderr, ": ");
+		vfprintf(stderr, fmt, ap);
+	}
+	fprintf(stderr, ": %s\n", strerror(errno));
+	va_end(ap);
+}
+
+void
+warnx(const char * fmt, ...)
+{
+	va_list ap;
+
+	va_start(ap, fmt);
+	fprintf(stderr, "%s", (name != NULL) ? name : "(unknown)");
+	if (fmt != NULL) {
+		fprintf(stderr, ": ");
+		vfprintf(stderr, fmt, ap);
+	}
+	fprintf(stderr, "\n");
+	va_end(ap);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/warnp.h tarsnap-autoconf-1.0.34/libcperciva/util/warnp.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/warnp.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/warnp.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,59 @@
+#ifndef _WARNP_H_
+#define _WARNP_H_
+
+#include <errno.h>
+
+/* Avoid namespace collisions with BSD <err.h>. */
+#define warn libcperciva_warn
+#define warnx libcperciva_warnx
+
+/**
+ * warnp_setprogname(progname):
+ * Set the program name to be used by warn() and warnx() to ${progname}.
+ */
+void warnp_setprogname(const char *);
+#define WARNP_INIT	do {		\
+	if (argv[0] != NULL)		\
+		warnp_setprogname(argv[0]);	\
+} while (0)
+
+/* As in BSD <err.h>. */
+void warn(const char *, ...);
+void warnx(const char *, ...);
+
+/*
+ * If compiled with DEBUG defined, print __FILE__ and __LINE__.
+ */
+#ifdef DEBUG
+#define warnline	do {				\
+	warnx("%s, %d", __FILE__, __LINE__);	\
+} while (0)
+#else
+#define warnline
+#endif
+
+/*
+ * Call warn(3) or warnx(3) depending upon whether errno == 0; and clear
+ * errno (so that the standard error message isn't repeated later).
+ */
+#define	warnp(...) do {					\
+	warnline;					\
+	if (errno != 0) {				\
+		warn(__VA_ARGS__);		\
+		errno = 0;				\
+	} else						\
+		warnx(__VA_ARGS__);		\
+} while (0)
+
+/*
+ * Call warnx(3) and set errno == 0.  Unlike warnp, this should be used
+ * in cases where we're reporting a problem which we discover ourselves
+ * rather than one which is reported to us from a library or the kernel.
+ */
+#define warn0(...) do {					\
+	warnline;					\
+	warnx(__VA_ARGS__);			\
+	errno = 0;					\
+} while (0)
+
+#endif /* !_WARNP_H_ */
diff -ruN tarsnap-autoconf-1.0.33/pkg/debian/changelog tarsnap-autoconf-1.0.34/pkg/debian/changelog
--- tarsnap-autoconf-1.0.33/pkg/debian/changelog	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/pkg/debian/changelog	2013-07-06 14:38:21.000000000 -0700
@@ -1,3 +1,16 @@
+tarsnap (1.0.34) unstable; urgency=low
+
+  * New version of tarsnap brings IPv6 support; support for platforms with
+    mandatory struct alignment (e.g., ARM OABI); and greater resilience
+    against network glitches when tarsnap first contacts the server.
+  * A bug causing tarsnap to crash when reading certain corrupt key files
+    on 64-bit platforms is fixed.
+  * Terminal settings are now restored if tarsnap is killed with ^C while
+    reading an account password or a keyfile passphrase.
+  * A large amount of library code has been restructured into an open
+    source "libcperciva" library.
+
+ -- Colin Percival <cperciva@tarsnap.com>  Say, 6 Jul 2013 21:33:46 +0000
 tarsnap (1.0.33) unstable; urgency=low
 
   * New version of tarsnap brings reduced memory usage on systems with a
@@ -5,7 +18,7 @@
     deleting or printing statistics for multiple archives; and corrects
     a bug in the handling of the --newerXXX option.
 
- -- Colin Percival <cperciva@tarsnap.com>  Wed, 1 Aug 2002 23:52:10 +0000
+ -- Colin Percival <cperciva@tarsnap.com>  Wed, 1 Aug 2012 23:52:10 +0000
 tarsnap (1.0.32) unstable; urgency=low
 
   * New version of tarsnap fixes a bug which made the --nodump option
diff -ruN tarsnap-autoconf-1.0.33/pkg/debian/copyright tarsnap-autoconf-1.0.34/pkg/debian/copyright
--- tarsnap-autoconf-1.0.33/pkg/debian/copyright	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/pkg/debian/copyright	2013-07-06 14:38:21.000000000 -0700
@@ -11,7 +11,7 @@
 Unless specified otherwise in individual files, the contents of this
 package is covered by the following copyright, license, and disclaimer:
 
-Copyright 2006, 2007, 2008, 2009, 2010, 2011 Colin Percival
+Copyright 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013 Colin Percival
 All rights reserved.
 
 Redistribution and use in source and binary forms, without modification,
diff -ruN tarsnap-autoconf-1.0.33/recrypt/recrypt.c tarsnap-autoconf-1.0.34/recrypt/recrypt.c
--- tarsnap-autoconf-1.0.33/recrypt/recrypt.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/recrypt/recrypt.c	2013-07-06 14:38:21.000000000 -0700
@@ -11,7 +11,7 @@
 #include "keyfile.h"
 #include "multitape_internal.h"
 #include "storage.h"
-#include "network.h"
+#include "tsnetwork.h"
 #include "tarsnap_opt.h"
 #include "warnp.h"
 
@@ -428,29 +428,17 @@
 	char *odirpath, *ndirpath;
 	FILE *odir, *ndir;
 
-#ifdef NEED_WARN_PROGNAME
-	warn_progname = "tarsnap-recrypt";
-#endif
+	WARNP_INIT;
 
 	/* Attempt to avoid buffering stdout since we print progress msgs. */
 	setvbuf(stdout, NULL, _IONBF, 0);
 
-	/* Initialize entropy subsystem. */
-	if (crypto_entropy_init()) {
-		warnp("Entropy subsystem initialization failed");
-		exit(1);
-	}
-
 	/* Initialize key cache. */
 	if (crypto_keys_init()) {
 		warnp("Key cache initialization failed");
 		exit(1);
 	}
 
-	/* Initialize network layer. */
-	if (network_init())
-		exit(1);
-
 	/* No options yet. */
 	ocachedir = ncachedir = NULL;
 	okeyfile = nkeyfile = NULL;
diff -ruN tarsnap-autoconf-1.0.33/tar/bsdtar.c tarsnap-autoconf-1.0.34/tar/bsdtar.c
--- tarsnap-autoconf-1.0.33/tar/bsdtar.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/bsdtar.c	2013-07-06 14:38:21.000000000 -0700
@@ -79,7 +79,7 @@
 #include "crypto.h"
 #include "keyfile.h"
 #include "humansize.h"
-#include "network.h"
+#include "tsnetwork.h"
 #include "tarsnap_opt.h"
 #include "warnp.h"
 
@@ -136,6 +136,8 @@
 	time_t			 now;
 	size_t 			 i;
 
+	WARNP_INIT;
+
 	/*
 	 * Use a pointer for consistency, but stack-allocated storage
 	 * for ease of cleanup.
@@ -163,9 +165,6 @@
 		else
 			bsdtar->progname = *argv;
 	}
-#ifdef NEED_WARN_PROGNAME
-	warn_progname = bsdtar->progname;
-#endif
 
 	/* We don't have a machine # yet. */
 	bsdtar->machinenum = (uint64_t)(-1);
@@ -189,18 +188,10 @@
 #endif
 	possible_help_request = 0;
 
-	/* Initialize entropy subsystem. */
-	if (crypto_entropy_init())
-		exit(1);
-
 	/* Initialize key cache.  We don't have any keys yet. */
 	if (crypto_keys_init())
 		exit(1);
 
-	/* Initialize network layer. */
-	if (network_init())
-		exit(1);
-
 	/*
 	 * Make stdout line-buffered (if possible) so that operations such as
 	 * "tarsnap --list-archives | more" will run more smoothly.  The only
@@ -554,7 +545,7 @@
 			add_substitution(bsdtar, bsdtar->optarg);
 #else
 			bsdtar_warnc(bsdtar, 0,
-			    "-s is not supported by this version of bsdtar");
+			    "-s is not supported by this version of tarsnap");
 			usage(bsdtar);
 #endif
 			break;
@@ -732,7 +723,10 @@
 	    (bsdtar->mode != OPTION_PRINT_STATS))
 		only_mode(bsdtar, "-f", "cxtdr");
 
-	/* These options don't make sense for "delete" and "convert to tar" */
+	/*
+	 * These options don't make sense for the "delete" and "convert to
+	 * tar" modes.
+	 */
 	if (bsdtar->pending_chdir)
 		only_mode(bsdtar, "-C", "cxt");
 	if (bsdtar->names_from_file)
@@ -1024,8 +1018,8 @@
 
 	fflush(stderr);
 
-	p = (strcmp(prog,"tarsnap") != 0) ? "(tarsnap)" : "";
-	printf("%s%s: efficiently manipulate multiple archives\n", prog, p);
+	p = (strcmp(prog, "tarsnap") != 0) ? "(tarsnap)" : "";
+	printf("%s%s: create and manipulate archives on the Tarsnap backup service\n", prog, p);
 
 	for (p = long_help_msg; *p != '\0'; p++) {
 		if (*p == '%') {
diff -ruN tarsnap-autoconf-1.0.33/tar/ccache/ccache_entry.c tarsnap-autoconf-1.0.34/tar/ccache/ccache_entry.c
--- tarsnap-autoconf-1.0.33/tar/ccache/ccache_entry.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/ccache/ccache_entry.c	2013-07-06 14:38:21.000000000 -0700
@@ -12,7 +12,7 @@
 #include "crypto.h"
 #include "multitape.h"
 #include "multitape_internal.h"
-#include "network.h"
+#include "tsnetwork.h"
 #include "patricia.h"
 #include "sysendian.h"
 #include "warnp.h"
@@ -24,12 +24,12 @@
 	struct ccache_internal * cci;	/* Cache data structure. */
 	struct ccache_record * ccr;	/* Actual cache entry. */
 	struct ccache_record ** ccrp;	/* Pointer to pointer in tree. */
-	int	hittrailer;		/* Non-zero if the multitape layer */
+	int hittrailer;			/* Non-zero if the multitape layer */
 					/* has told us about a trailer. */
-	uint8_t *	trailer;	/* Uncompressed trailer. */
-	ino_t	ino_new;		/* New inode number. */
-	off_t	size_new;		/* New file size. */
-	time_t	mtime_new;		/* New modification time. */
+	uint8_t * trailer;		/* Uncompressed trailer. */
+	ino_t ino_new;			/* New inode number. */
+	off_t size_new;			/* New file size. */
+	time_t mtime_new;		/* New modification time. */
 };
 
 static int callback_addchunk(void *, struct chunkheader *);
diff -ruN tarsnap-autoconf-1.0.33/tar/config_freebsd.h tarsnap-autoconf-1.0.34/tar/config_freebsd.h
--- tarsnap-autoconf-1.0.33/tar/config_freebsd.h	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/config_freebsd.h	2013-07-06 14:38:21.000000000 -0700
@@ -56,7 +56,6 @@
 #define	HAVE_FNMATCH_H 1
 #define	HAVE_FNM_LEADING_DIR 1
 #define	HAVE_FTRUNCATE 1
-#define	HAVE_GETADDRINFO 1
 #undef	HAVE_GETXATTR
 #define	HAVE_GRP_H 1
 #define	HAVE_INTTYPES_H 1
diff -ruN tarsnap-autoconf-1.0.33/tar/glue/archive_multitape.c tarsnap-autoconf-1.0.34/tar/glue/archive_multitape.c
--- tarsnap-autoconf-1.0.33/tar/glue/archive_multitape.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/glue/archive_multitape.c	2013-07-06 14:38:21.000000000 -0700
@@ -4,7 +4,7 @@
 
 #include "archive.h"
 #include "multitape.h"
-#include "network.h"
+#include "tsnetwork.h"
 #include "warnp.h"
 
 #include "archive_multitape.h"
diff -ruN tarsnap-autoconf-1.0.33/tar/multitape/chunkify.c tarsnap-autoconf-1.0.34/tar/multitape/chunkify.c
--- tarsnap-autoconf-1.0.33/tar/multitape/chunkify.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/multitape/chunkify.c	2013-07-06 14:38:21.000000000 -0700
@@ -339,7 +339,7 @@
 		c->yka -= c->p & (((c->yka - c->p) >> 31) - 1);
 
 		/* a^k := a^k * alpha mod p */
-		/* akr <= p * 2^32 / (2^32 - p)) */
+		/* akr <= p * 2^32 / (2^32 - p) */
 		c->akr = mmul(c->akr, c->ar, c->p, c->pp);
 
 		/*
diff -ruN tarsnap-autoconf-1.0.33/tar/multitape/multitape_internal.h tarsnap-autoconf-1.0.34/tar/multitape/multitape_internal.h
--- tarsnap-autoconf-1.0.33/tar/multitape/multitape_internal.h	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/multitape/multitape_internal.h	2013-07-06 14:38:21.000000000 -0700
@@ -4,6 +4,7 @@
 #include <stdint.h>
 
 #include "chunks.h"
+#include "ctassert.h"
 #include "storage.h"
 
 /* On-disk chunk header structure.  Integers are little-endian. */
@@ -12,6 +13,7 @@
 	uint8_t len[4];
 	uint8_t zlen[4];
 };
+CTASSERT(sizeof(struct chunkheader) == 40);
 
 /* On-disk entry header structure. */
 struct entryheader {
@@ -19,6 +21,7 @@
 	uint8_t clen[8];
 	uint8_t tlen[4];
 };
+CTASSERT(sizeof(struct entryheader) == 16);
 
 /* Archive metadata structure. */
 struct tapemetadata {
diff -ruN tarsnap-autoconf-1.0.33/tar/multitape/multitape_metadata.c tarsnap-autoconf-1.0.34/tar/multitape/multitape_metadata.c
--- tarsnap-autoconf-1.0.33/tar/multitape/multitape_metadata.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/multitape/multitape_metadata.c	2013-07-06 14:38:21.000000000 -0700
@@ -7,6 +7,7 @@
 #include <string.h>
 
 #include "crypto.h"
+#include "crypto_verify_bytes.h"
 #include "storage.h"
 #include "sysendian.h"
 #include "warnp.h"
diff -ruN tarsnap-autoconf-1.0.33/tar/multitape/multitape_metaindex.c tarsnap-autoconf-1.0.34/tar/multitape/multitape_metaindex.c
--- tarsnap-autoconf-1.0.33/tar/multitape/multitape_metaindex.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/multitape/multitape_metaindex.c	2013-07-06 14:38:21.000000000 -0700
@@ -6,6 +6,8 @@
 #include <stdlib.h>
 #include <string.h>
 
+#include "crypto.h"
+#include "crypto_verify_bytes.h"
 #include "sysendian.h"
 #include "warnp.h"
 
diff -ruN tarsnap-autoconf-1.0.33/tar/multitape/multitape_transaction.c tarsnap-autoconf-1.0.34/tar/multitape/multitape_transaction.c
--- tarsnap-autoconf-1.0.33/tar/multitape/multitape_transaction.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/multitape/multitape_transaction.c	2013-07-06 14:38:21.000000000 -0700
@@ -12,7 +12,7 @@
 #include <unistd.h>
 
 #include "chunks.h"
-#include "crypto.h"
+#include "crypto_entropy.h"
 #include "dirutil.h"
 #include "hexify.h"
 #include "hexlink.h"
diff -ruN tarsnap-autoconf-1.0.33/tar/storage/storage.h tarsnap-autoconf-1.0.34/tar/storage/storage.h
--- tarsnap-autoconf-1.0.33/tar/storage/storage.h	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/storage/storage.h	2013-07-06 14:38:21.000000000 -0700
@@ -58,7 +58,7 @@
  * storage_read_file_callback(S, buf, buflen, class, name, callback, cookie):
  * Read the file ${name} from class ${class} using the read cookie ${S}
  * returned from storage_read_init.  If ${buf} is non-NULL, then read the
- * file (which should be ${buflen} bytes in length} into ${buf}; otherwise
+ * file (which should be ${buflen} bytes in length) into ${buf}; otherwise
  * malloc a buffer.  Invoke ${callback}(${cookie}, status, b, blen) when
  * complete, where ${status} is 0, 1, 2, or -1 as per storage_read_file,
  * ${b} is the buffer into which the data was read (which will be ${buf} if
diff -ruN tarsnap-autoconf-1.0.33/tar/storage/storage_directory.c tarsnap-autoconf-1.0.34/tar/storage/storage_directory.c
--- tarsnap-autoconf-1.0.33/tar/storage/storage_directory.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/storage/storage_directory.c	2013-07-06 14:38:21.000000000 -0700
@@ -5,6 +5,7 @@
 #include <string.h>
 
 #include "crypto.h"
+#include "crypto_entropy.h"
 #include "netpacket.h"
 #include "netproto.h"
 #include "storage_internal.h"
diff -ruN tarsnap-autoconf-1.0.33/tar/storage/storage_read.c tarsnap-autoconf-1.0.34/tar/storage/storage_read.c
--- tarsnap-autoconf-1.0.33/tar/storage/storage_read.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/storage/storage_read.c	2013-07-06 14:38:21.000000000 -0700
@@ -391,7 +391,7 @@
  * storage_read_file_callback(S, buf, buflen, class, name, callback, cookie):
  * Read the file ${name} from class ${class} using the read cookie ${S}
  * returned from storage_read_init.  If ${buf} is non-NULL, then read the
- * file (which should be ${buflen} bytes in length} into ${buf}; otherwise
+ * file (which should be ${buflen} bytes in length) into ${buf}; otherwise
  * malloc a buffer.  Invoke ${callback}(${cookie}, status, b, blen) when
  * complete, where ${status} is 0, 1, 2, or -1 as per storage_read_file,
  * ${b} is the buffer into which the data was read (which will be ${buf} if
diff -ruN tarsnap-autoconf-1.0.33/tar/storage/storage_transaction.c tarsnap-autoconf-1.0.34/tar/storage/storage_transaction.c
--- tarsnap-autoconf-1.0.33/tar/storage/storage_transaction.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/storage/storage_transaction.c	2013-07-06 14:38:21.000000000 -0700
@@ -6,6 +6,7 @@
 #include <unistd.h>
 
 #include "crypto.h"
+#include "crypto_entropy.h"
 #include "netpacket.h"
 #include "netproto.h"
 #include "warnp.h"
diff -ruN tarsnap-autoconf-1.0.33/tar/write.c tarsnap-autoconf-1.0.34/tar/write.c
--- tarsnap-autoconf-1.0.33/tar/write.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/tar/write.c	2013-07-06 14:38:21.000000000 -0700
@@ -97,7 +97,7 @@
 #include "archive_multitape.h"
 #include "ccache.h"
 #include "getfstype.h"
-#include "network.h"
+#include "tsnetwork.h"
 #include "sigquit.h"
 
 /* Size of buffer for holding file data prior to writing. */
